#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

char * allocate_space(char *oldptr, int current_size, int max_characters) {
  
  // Allocate a new array
  char *newinput = (char*)malloc(max_characters*sizeof(char));
  printf("Allocated new memory for %d chars\n", max_characters);
  // if there was an old array copy it into the new one.
  if (current_size > 0) {
    for (int i=0; i<current_size; i++) {
      newinput[i] = oldptr[i];
    }
    // Reclaim the old memory
    assert(oldptr != NULL);
    printf("Free'd old memory!\n");
    free(oldptr);
  } else {
    assert(oldptr == NULL);
  }

  return newinput;
}

int main(int argc, char *argv[]) {

  char *input = NULL;
  int max_characters = 2;

  int characters = 0;

  input = allocate_space(input, 0, max_characters);

  while (1) {
    char c = getc(stdin);
    if (c == EOF) {
      break;
    }
    // Add to the array
    input[characters] = c;

    characters++;

    if (characters >= max_characters) {
      input = allocate_space(input, characters, max_characters*2);
      max_characters *= 2;
    }
  }

  // MAKE SURE TO PUT AN '\0' at the end of the array to make it a string!!!
  input[characters] = '\0';

  printf("You entered\n");
  printf("%s\n", input);

  return 0;
}
